<!DOCTYPE html>
<html lang="en">
<head>
    <title>P4 - 2D</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0">
    <style>
        body {
            background-color: #000000;
            margin: 0px;
            overflow: hidden;
        }

        .info{
            position:absolute;
            left:50%;
            top: 50%;
            margin:auto;
            width:50%;
            height:100px;
            margin-left:-25%;
            z-index: 99999;
            color: white;
            text-align: center;
            display:none;
        }
        .data{
            position:absolute;
            left:50%;
            top: 10%;
            margin:auto;
            width:50%;
            height:100px;
            margin-left:-25%;
            z-index: 99999;
            color: white;
            text-align: center;
            display:none;
        }

    </style>
</head>
<body>

<div id="container"></div>
<div id="info" class="info" ></div>
<div id="data" class="data" >llllll</div>

<script src="js/three.min.js"></script>
<script src="js/DeviceOrientationControls.js"></script>
<script src="js/DeviceOrientationControls_a5.js"></script>

<script>
  
  var gyroPresent = false; 
  /*
  window.addEventListener("devicemotion", function(event){ 
    if(event.rotationRate.alpha || event.rotationRate.beta || event.rotationRate.gamma) gyroPresent = true; 
  });
  */

  
  
  if (!window.WebGLRenderingContext) {
    // the browser doesn't even know what WebGL is
    window.location = "nowebgl_1.html";
  } else {
    var canvas = document.createElement( 'canvas' );
    var context = canvas.getContext("webgl");
    if (!context) {
      // browser supports WebGL but initialization failed.
      window.location = "nowebgl_1.html";
    }
  } 
  /*
  window.addEventListener("deviceorientation", function(event){ 
    if(event.rotationRate.alpha || event.rotationRate.beta || event.rotationRate.gamma) {
      gyroPresent = true;
    }else{
      // browser supports DeviceOrientation but initialization failed.
      window.location = "nowebgl_1.html";
    }
  });
*/
  
    var waitTimes;
    var timerId1 = 0;
    var timerId2 = 0;
    
    var enablePoints = false;
    var timerIdStart = 0;


    var filePathPrefix = '';
    var imageFilePath = filePathPrefix + 'img/pan-1-left.jpg';

    var camera, scene, renderer, effect, controls;
    var isUserInteracting = false,
            onMouseDownMouseX = 0, onMouseDownMouseY = 0,
            lon = 0, onMouseDownLon = 0,
            lat = 0, onMouseDownLat = 0,
            phi = 0, theta = 0;

  
  
  var loader = new THREE.TextureLoader();
  var material = null;

    // load a resource
    loader.load(
          // resource URL
          imageFilePath,
        
          // Function when resource is loaded
          function ( texture ) {
              // do something with the texture
              material = new THREE.MeshBasicMaterial( {map: texture } );
		      init();
		      animate();
          }
    );

      
    function init() {
        var container, mesh;
        container = document.getElementById( 'container' );

        camera = new THREE.PerspectiveCamera( 75, window.innerWidth / window.innerHeight, 1, 1100 );

        controls = new THREE.DeviceOrientationControls( camera );
        //controls = new THREE.DeviceOrientationControls_a5(camera, true);

        var ua = navigator.userAgent;
        console.log("ua=",ua);
        console.log("ua.lastIndexOf('samsung;SM-A510')=",(ua.lastIndexOf('samsung;SM-A510')>0));

    /*
        if (ua.lastIndexOf('samsung;SM-A510')>0 ){
            controls = new THREE.DeviceOrientationControls_a5(camera, true);
        }else{
            controls = new THREE.DeviceOrientationControls(camera, true);
        }
     */

        controls.connect();
        controls.update();

        scene = new THREE.Scene();

        var geometry = new THREE.SphereGeometry( 1000, 60, 60 );
        geometry.scale( - 1, 1, 1 );
        //var material = new THREE.MeshBasicMaterial( { map: new THREE.TextureLoader().load( imageFilePath ) } );
      
        mesh = new THREE.Mesh( geometry, material );
        scene.add( mesh );

        renderer = new THREE.WebGLRenderer();
        renderer.setPixelRatio( window.devicePixelRatio );
        renderer.setSize( window.innerWidth, window.innerHeight );
        container.appendChild( renderer.domElement );
        
        timerIdStart = setInterval(goTimerStart, 3000);

    }

  function animate() {
     //console.log("userAgent=",navigator.userAgent);

      requestAnimationFrame( animate );
      camera.updateProjectionMatrix();
      controls.update();
      renderer.render( scene, camera );

      if (!enablePoints){return;}

      v = camera.getWorldDirection();
      pos_x = -100;
      pos_y = 100;
      pos_y_2 = 950;
      pos_r = 150;
      pos_res = "false";

      if ((Math.abs(Math.round(v.x*1000) - pos_x) < pos_r) && (Math.abs(Math.round(v.y*1000) - pos_y) < 800) && (v.z < 0)){
          if (timerId1==0) {
              pos_res = "true";
              waitTimes = 3;
              document.getElementById( 'info' ).style.display="block";
              goTimer1();
              timerId1 = setInterval(goTimer1, 1000);
          }
      }else{
          if (timerId1!=0){
              clearTimeout(timerId1);
              timerId1 = 0;
              waitTimes = 3;
              document.getElementById( 'info' ).innerHTML = "";
          }
      };


      if (Math.abs(Math.abs(Math.round(v.y*1000)) - pos_y_2) < pos_r){
          if (timerId2==0) {
              pos_res = "true";
              waitTimes = 3;
              document.getElementById( 'info' ).style.display="block";
              goTimer2();
              timerId2 = setInterval(goTimer2, 1000);
          }
      }else{
          if (timerId2!=0){
              clearTimeout(timerId2);
              timerId2 = 0;
              waitTimes = 3;
              document.getElementById( 'info' ).innerHTML = "";
          }
      };

      //document.getElementById( 'info' ).innerHTML ="Go("+waitTimes+"): dX:"+ Math.abs(Math.round(v.x*1000) - pos_x)+", dY:"+(Math.abs(Math.round(v.y*1000) - pos_y)+",   x="+Math.round(v.x*1000)+", y="+Math.round(v.y*1000)+", z="+Math.round(v.z*1000));

  }


    function update(dt) {
        resize();
        camera.updateProjectionMatrix();
        controls.update(dt);
    }

    function goTimer1(){
      document.getElementById( 'info' ).innerHTML ="Вход в музей<br/>"+waitTimes+" сек.";
      document.getElementById( 'info' ).style.display="block";
        waitTimes--;
        if (waitTimes<0){
            //alert("waitTimes="+waitTimes);
            window.location = "2d-2.html";
        }
        //document.getElementById( 'info' ).innerHTML ="Go("+waitTimes+"):"+pos_res+",   x="+Math.round(v.x*1000)+", y="+Math.round(v.y*1000)+", z="+Math.round(v.z*1000);
    }

    function goTimer2(){
        document.getElementById( 'info' ).innerHTML ="Выход через<br/>"+waitTimes+" сек.";
        document.getElementById( 'info' ).style.display="block";
        waitTimes--;
        if (waitTimes<0){
            //alert("Exit");
            window.location = "exit://";
        }
        //document.getElementById( 'info' ).innerHTML ="Go("+waitTimes+"):"+pos_res+",   x="+Math.round(v.x*1000)+", y="+Math.round(v.y*1000)+", z="+Math.round(v.z*1000);
    }

    function goTimerStart(){
      enablePoints = true;
      clearTimeout(timerIdStart);
    }

    console.log("navigator.userAgent=",navigator.userAgent);

</script>
</body>
</html>